"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const operations_1 = __importDefault(require("../operations"));
const requestValidation_1 = require("./requestValidation");
const types_1 = require("./types");
const express_1 = __importDefault(require("express"));
function routes(options) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        const userDataEntries = [];
        for (const method in securityRequirement) {
            const user = await options.security[method](request, securityRequirement[method]);
            if (!(0, types_1.isUserType)(user))
                throw new Error(`User resolved by method ${method} is not of type 'UserType'`);
            userDataEntries.push([method, user]);
        }
        return Object.fromEntries(userDataEntries);
    }
    router.get('/updates', async (req, res, next) => {
        const security = [
            {
                JWT: ['update', 'update:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetUpdatesInput)()) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetUpdatesInput.errors, 400);
            }
            const result = await operations_1.default.getUpdates(userData);
            if (!(0, requestValidation_1.validateGetUpdatesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetUpdatesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/updates', async (req, res, next) => {
        const security = [
            {
                JWT: ['update', 'update:create'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostUpdatesInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostUpdatesInput.errors, 400);
            }
            const result = await operations_1.default.postUpdates(body, userData);
            if (!(0, requestValidation_1.validatePostUpdatesOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostUpdatesOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/updates/:device_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['update', 'update:read'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
            current_version: req.query['current_version'],
        };
        try {
            if (!(0, requestValidation_1.validateGetUpdatesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetUpdatesByDeviceIdInput.errors, 400);
            }
            const result = await operations_1.default.getUpdatesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateGetUpdatesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetUpdatesByDeviceIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch('/updates/:device_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['update', 'update:write'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchUpdatesByDeviceIdInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePatchUpdatesByDeviceIdInput.errors, 400);
            }
            const result = await operations_1.default.patchUpdatesByDeviceId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchUpdatesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePatchUpdatesByDeviceIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/updates/:device_id', async (req, res, next) => {
        const security = [
            {
                JWT: ['update', 'update:delete'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            device_id: req.params['device_id'],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteUpdatesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeleteUpdatesByDeviceIdInput.errors, 400);
            }
            const result = await operations_1.default.deleteUpdatesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteUpdatesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeleteUpdatesByDeviceIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map