"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InvalidChangeError = exports.MissingEntityError = void 0;
const types_1 = require("../generated/types");
/**
 * This error class should be used if an entity is not found in the database.
 */
class MissingEntityError extends types_1.ErrorWithStatus {
    constructor(message, status) {
        super(message, status);
        this.name = 'MissingEntityError';
    }
}
exports.MissingEntityError = MissingEntityError;
/**
 * This error class should be used if the user attempts an invalid change.
 */
class InvalidChangeError extends types_1.ErrorWithStatus {
    constructor(message, status) {
        super(message, status);
        this.name = 'InvalidChangeError';
    }
}
exports.InvalidChangeError = InvalidChangeError;
//# sourceMappingURL=errors.js.map